//
//   }bvGł Version 1.11
//
//     2003/10/21   ˁ@P
//

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ExtDlgs, Menus,ShellAPI, ComCtrls;

type

  TpatBMP=array[0..99]of TBitmap;
  TMap=array[0..255,0..255] of Byte;

  TForm1 = class(TForm)
    mapP: TPanel;
    mapI: TImage;
    hScrollB: TScrollBar;
    vScrollB: TScrollBar;
    LeftBI: TImage;
    rightBI: TImage;
    rightBP: TPanel;
    leftBP: TPanel;
    MainMenu1: TMainMenu;
    FileMenu: TMenuItem;
    LoadPartsM: TMenuItem;
    LoadBMPD: TOpenPictureDialog;
    DefMenu: TMenuItem;
    V1: TMenuItem;
    V1M: TMenuItem;
    V2M: TMenuItem;
    V3M: TMenuItem;
    C1: TMenuItem;
    cs2M: TMenuItem;
    cs1M: TMenuItem;
    cs3M: TMenuItem;
    cs4M: TMenuItem;
    cs5M: TMenuItem;
    editP: TPanel;
    editBox: TScrollBox;
    chrI: TImage;
    S1: TMenuItem;
    c1M: TMenuItem;
    c2M: TMenuItem;
    c3M: TMenuItem;
    c4M: TMenuItem;
    c5M: TMenuItem;
    memSaveB: TButton;
    memLoadB: TButton;
    SaveMenu: TMenuItem;
    LoadMenu: TMenuItem;
    moveMenu: TMenuItem;
    upMenu: TMenuItem;
    rightMenu: TMenuItem;
    downMenu: TMenuItem;
    leftMenu: TMenuItem;
    editMenu: TMenuItem;
    undoMenu: TMenuItem;
    loadDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    aboutMenu: TMenuItem;
    writeMenu: TMenuItem;
    N1: TMenuItem;
    exitMenu: TMenuItem;
    sbBar: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure mapIMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mapIMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure chrIMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FileMenuClick(Sender: TObject);
    procedure vScrollBChange(Sender: TObject);
    procedure hScrollBChange(Sender: TObject);
    procedure DefMenuClick(Sender: TObject);
    procedure csMenuClick(Sender: TObject);
    procedure ccMClick(Sender: TObject);
    procedure memButtonClick(Sender: TObject);
    procedure moveMenuClick(Sender: TObject);
    procedure undoMenuClick(Sender: TObject);
    procedure aboutMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    cSize,vSize,cxSize,cySize,vn:Integer;
    vx,vy,x,y,rc,lc,mcs,mcx,mcy,mrc,mlc:Integer;
    ud,ov,mov:Boolean;
    fn,mfn:String;
    Map,memMap,unMap:TMap;
    patBMP:TpatBMP;

    chrBMP,mapBMP,saveBMP:TBitmap;

    procedure initChr(cs,xs,ys:Integer);
    procedure drawMap;
    procedure drawChrLine;
    procedure drawChr;
    procedure putChr(c,x,y:Integer);
    procedure loadParts(FileName:String);
    procedure loadMap(FileName:String);
    procedure saveMap(FileName:String);
    procedure DropFiles(var Msg:TWMDROPFILES); message WM_DROPFILES;

  end;

var
  Form1: TForm1;

  const xSize=256;
  const ySize=256;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j:Integer;
begin

  chrBMP:=TBitmap.Create;
  mapBMP:=TBitmap.Create;
  saveBMP:=TBitmap.Create;

  vx:=0;
  vy:=0;
  x:=0;
  y:=0;
  fn:='';
  ud:=False;
  ov:=False;

  loadDialog.Options:=[ofFileMustExist,ofHideReadOnly];
  loadBMPD.Options:=[ofFileMustExist,ofHideReadOnly];
  saveDialog.Options:=[ofOverwritePrompt,ofHideReadOnly];

  for i:=0 to xSize-1 do
    for j:=0 to ySize-1 do
      Map[j,i]:=0;

  for i:=0 to xSize-1 do
    for j:=0 to ySize-1 do
      unMap[j,i]:=4;

  for i:=0 to 99 do
    patBMP[i]:=TBitmap.Create;

  lc:=0;
  rc:=1;
  vSize:=24;
  initChr(24,6,6);

  drawMap;
  DragAcceptFiles(Form1.Handle,True); // t@Chbvݒ


end;

procedure TForm1.initChr(cs,xs,ys:Integer);
var
  i,j:Integer;
  tBMP:TBitmap;
begin

  drawChr;

  cSize:=cs;
  cxSize:=xs;
  cySize:=ys;

  if v1M.Checked then
    vSize:=cSize
  else if v2M.Checked then
    vSize:=cSize div 2
  else if v3M.Checked then
    vSize:=cSize div 4;

  vn:=480 div vSize;

  vScrollB.Enabled:=False;
  hScrollB.Enabled:=False;

  vScrollB.Max:=256-vn;
  hScrollB.Max:=256-vn;

  if hScrollB.Position>hScrollB.Max then
    hScrollB.Position:=hScrollB.Max;

  if vScrollB.Position>vScrollB.Max then
    vScrollB.Position:=vScrollB.Max;

  hScrollB.Enabled:=True;
  vScrollB.Enabled:=True;

  vx:=hScrollB.Position;
  vy:=vScrollB.Position;

  tBMP:=TBitmap.Create;
  tBMP.Width:=cSize*cxSize;
  tBMP.Height:=cSize*cySize;
  tBMP.Canvas.Brush.Color:=clBlack;
  tBMP.Canvas.FillRect(Rect(0,0,tBMP.Width,tBMP.Height));
  tBMP.Canvas.Draw(0,0,chrBMP);

  for i:=0 to cxSize-1 do
    for j:=0 to cySize-1 do
    begin

      patBMP[j+i*cxSize].Width:=cSize;
      patBMP[j+i*cxSize].Height:=cSize;

      patBMP[j+i*cxSize].Canvas.CopyRect(Rect(0,0,cSize,cSize),
        tBMP.Canvas,Rect(j*cSize,i*cSize,(j+1)*cSize,(i+1)*cSize));

    end;

  chrI.Picture.Bitmap.Width:=cSize*cxSize;
  chrI.Picture.Bitmap.Height:=cSize*cySize;

  chrBMP.Width:=cSize*cxSize;
  chrBMP.Height:=cSize*cySize;
  drawChr;
  chrI.Canvas.draw(0,0,chrBMP);
  drawChrLine;
  editBox.Refresh;

  if chrI.Width<260 then
    editBox.Width:=chrI.Width
  else
    editBox.Width:=260;

  if chrI.Height<260 then
    editBox.Height:=chrI.Height
  else
    editBox.Height:=260;

  editP.Width:=editBox.Width+2;
  editP.Height:=editBox.Height+2;

  leftBI.Picture.Bitmap.Width:=cSize;
  leftBI.Picture.Bitmap.Height:=cSize;
  leftBI.Top:=editP.Top+editP.Height+16;
  leftBP.Top:=leftBI.Top+LeftBI.height-20;
  leftBP.Left:=leftBI.Left+leftBI.Width+2;
  leftBP.Caption:=intToStr(lc);

  rightBI.left:=leftBI.Left+leftBI.Width+leftBP.width+8;
  rightBI.Picture.Bitmap.Width:=cSize;
  rightBI.Picture.Bitmap.Height:=cSize;
  rightBI.Top:=editP.Top+editP.Height+16;
  rightBP.Top:=rightBI.Top+rightBI.height-20;
  rightBP.Left:=rightBI.Left+rightBI.width+2;
  rightBP.Caption:=intToStr(rc);

  leftBI.Canvas.Draw(0,0,patBMP[lc]);
  rightBI.Canvas.Draw(0,0,patBMP[rc]);

  drawMap;

  tBMP.Free;

end;

procedure TForm1.drawMap;
var
  i,j:Integer;
  tBMP:TBitmap;
begin

  tBMP:=TBitmap.Create;
  tBMP.Width:=mapI.Width;
  tBMP.Height:=mapI.Height;

  for i:=0 to vn-1 do
    for j:=0 to vn-1 do
      tBMP.Canvas.StretchDraw(Rect(j*vSize,i*vSize,(j+1)*vSize,(i+1)*vSize),
        patBMP[Map[vx+j,vy+i]]);

  mapI.Canvas.Draw(0,0,tBMP);

  tBMP.Free;

end;

procedure TForm1.putChr(c,x,y:Integer);
begin

  Map[x,y]:=c;

  mapI.Canvas.StretchDraw(Rect((x-vx)*vSize,(y-vy)*vSize,(x-vx+1)*vSize,
    (y-vy+1)*vSize),patBMP[Map[x,y]]);

end;

procedure TForm1.drawChr;
var
  i,j:Integer;
begin

  for i:=0 to cySize-1 do
    for j:=0 to cxSize-1 do
      chrBMP.Canvas.Draw(j*cSize,i*cSize,patBMP[i*cxSize+j]);

end;

procedure TForm1.drawChrLine;
var
  i:Integer;
begin

  chrI.Canvas.Pen.Color:=clGray;

  for i:=1 to cxSize do
    chrI.Canvas.PolyLine([Point(i*cSize,0),Point(i*cSize,cSize*cySize)]);

  for i:=1 to cySize do
    chrI.Canvas.PolyLine([Point(0,i*cSize),Point(cSize*cxSize,i*cSize)]);

  chrI.Canvas.Brush.Color:=clRed;
  chrI.Canvas.FrameRect(Rect((lc mod cxSize)*cSize,(lc div cxSize)*cSize,
     (lc mod cxSize+1)*cSize,(lc div cxSize+1)*cSize));

  chrI.Canvas.Brush.Color:=clBlue;
  chrI.Canvas.FrameRect(Rect((rc mod cxSize)*cSize,(rc div cxSize)*cSize,
     (rc mod cxSize+1)*cSize,(rc div cxSize+1)*cSize));

end;

procedure TForm1.mapIMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  ex,ey:Integer;
begin

  ex:=X div vSize+vx;
  ey:=Y div vSize+vy;

  sbBar.SimpleText:='('+intToStr(ex)+' , '+intToStr(ey)+')'+
    ' - '+intToStr(Map[ex,ey]);

  if Shift=[ssLeft] then
    putChr(lc,ex,ey)
  else if Shift=[ssRight] then
    putChr(rc,ex,ey);

end;

procedure TForm1.mapIMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i,j,ex,ey:Integer;
  tBMP:TBitmap;
begin

  ex:=(X div vSize)+vx;
  ey:=(Y div vSize)+vy;

  ov:=True;

  if Shift=[ssLeft,ssShift] then
  begin

    unMap:=Map;

    tBMP:=TBitmap.Create;
    tBMP.Width:=xSize;
    tBMP.Height:=ySize;
    tBMP.HandleType:=bmDIB;
    tBMP.PixelFormat:=pf24bit;
    tBMP.Canvas.Brush.Color:=clWhite;
    tBMP.Canvas.FillRect(Rect(0,0,xSize,ySize));

    for i:=0 to ySize-1 do
      for j:=0 to xSize-1 do
        if Map[j,i]=Map[ex,ey] then
          tBMP.Canvas.Pixels[j,i]:=clBlack;

    tBMP.Canvas.Brush.Color:=clRed;
    tBMP.Canvas.FloodFill(ex,ey,tBMP.Canvas.Pixels[ex,ey],fsSurface);

    for i:=0 to ySize-1 do
      for j:=0 to xSize-1 do
        if tBMP.Canvas.Pixels[j,i]=clRed then
          Map[j,i]:=lc;

    drawMap;
    ud:=True;

    tBMP.Free;

  end
  else if Shift=[ssRight,ssShift] then
  begin

    unMap:=Map;

    tBMP:=TBitmap.Create;
    tBMP.Width:=xSize;
    tBMP.Height:=ySize;
    tBMP.HandleType:=bmDIB;
    tBMP.PixelFormat:=pf24bit;
    tBMP.Canvas.Brush.Color:=clWhite;
    tBMP.Canvas.FillRect(Rect(0,0,xSize,ySize));

    for i:=0 to ySize-1 do
      for j:=0 to xSize-1 do
        if Map[j,i]=Map[ex,ey] then
          tBMP.Canvas.Pixels[j,i]:=clBlack;

    tBMP.Canvas.Brush.Color:=clRed;
    tBMP.Canvas.FloodFill(ex,ey,tBMP.Canvas.Pixels[ex,ey],fsSurface);

    for i:=0 to ySize-1 do
      for j:=0 to xSize-1 do
        if tBMP.Canvas.Pixels[j,i]=clRed then
          Map[j,i]:=rc;

    drawMap;
    ud:=True;

    tBMP.Free;

  end
  else if Shift=[ssLeft] then
  begin

    putChr(lc,ex,ey);
    ud:=False;

  end
  else if Shift=[ssRight] then
  begin

    putChr(rc,ex,ey);
    ud:=False;

  end;

  mapI.Refresh;

end;

procedure TForm1.chrIMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  ex,ey:Integer;
begin

  ex:=X div cSize;
  ey:=Y div cSize;

  if Button=mbLeft then
  begin

    lc:=ey*cxSize+ex;
    leftBP.Caption:=intToStr(ey*cxSize+ex);
    leftBI.Canvas.Draw(0,0,patBMP[ey*cxSize+ex]);

  end
  else if Button=mbRight then
  begin

    rc:=ey*cxSize+ex;
    rightBP.Caption:=intToStr(ey*cxSize+ex);
    rightBI.Canvas.Draw(0,0,patBMP[ey*cxSize+ex]);

  end;

  drawChr;
  chrI.Canvas.Draw(0,0,chrBMP);
  drawChrLine;

end;

procedure TForm1.FileMenuClick(Sender: TObject);
var
  tBMP:TBitmap;
  i,j:Integer;
  MapDat:File of TMap;
begin

  if Sender=FileMenu then
    writeMenu.Enabled:=ov;

  if Sender=LoadPartsM then
  begin

    if not(LoadBMPD.Execute) then
      Exit;

    loadParts(LoadBMPD.FileName);

  end;

  if Sender=saveMenu then
  begin

    if not(saveDialog.Execute) then
      Exit;

    saveMap(saveDialog.FileName);

  end;

  if Sender=loadMenu then
  begin

    if not(loadDialog.Execute) then
      Exit;

    loadMap(loadDialog.FileName);

  end;

  if Sender=writeMenu then
  begin

    saveMap(fn);
    ov:=False;

  end;

  if Sender=exitMenu then
    Close;

end;

procedure TForm1.loadParts(FileName:String);
var
  i,j:Integer;
  tBMP:TBitmap;
begin

  tBMP:=TBitmap.Create;

  tBMP.LoadFromFile(FileName);

  chrBMP.Canvas.Brush.Color:=clBlack;
  chrBMP.Canvas.FillRect(Rect(0,0,chrBMP.Width,chrBMP.Height));
  chrBMP.Canvas.Draw(0,0,tBMP);

  for i:=0 to cySize-1 do
    for j:=0 to cxSize-1 do
      patBMP[j+i*cxSize].Canvas.CopyRect(Rect(0,0,cSize,cSize),
        chrBMP.Canvas,Rect(j*cSize,i*cSize,(j+1)*cSize,(i+1)*cSize));

  drawChr;
  initChr(cSize,cxSize,cySize);

  tBMP.Free;

end;

procedure TForm1.loadMap(FileName:String);
var
  MapDat:File of TMap;
  fh:File of Byte;
  i,j,s:Integer;
begin

  AssignFile(fh,FileName);
  Reset(fh);
  s:=FileSize(fh);
  CloseFile(fh);

  if not(s=xSize*ySize) then
  begin

    ShowMessage('̃t@C̓}bvf[^ł͂܂I');
    Exit;

  end;

  AssignFile(MapDat,FileName);
  Reset(MapDat);
  Read(MapDat,Map);
  CloseFile(MapDat);

  for i:=0 to ySize-1 do
    for j:=0 to xSize-1 do
      if Map[j,i]>=cxSize*cySize then
        Map[j,i]:=0;

  fn:=FileName;
  Caption:='}bvGł|'+fn;

  drawMap;

end;

procedure TForm1.saveMap(FileName:String);
var
  MapDat:File of TMap;
begin

  if FileName='' then
  begin

    if not(saveDialog.Execute) then
      Exit
    else
      FileName:=saveDialog.FileName;

  end;

  AssignFile(MapDat,FileName);

  Rewrite(MapDat);
  Write(MapDat,Map);
  CloseFile(MapDat);

  fn:=FileName;
  Caption:='}bvGł|'+fn;

end;

procedure TForm1.vScrollBChange(Sender: TObject);
begin

  if not(vScrollB.Enabled) then
    Exit;

  vy:=vScrollB.Position;
  drawMap;

end;

procedure TForm1.hScrollBChange(Sender: TObject);
begin

  if not(hScrollB.Enabled) then
    Exit;

  vx:=hScrollB.Position;
  drawMap;

end;

procedure TForm1.DefMenuClick(Sender: TObject);
begin

  TMenuItem(Sender).Checked:=True;

  if Sender=V1M then
    vSize:=cSize
  else if Sender=V2M then
    vSize:=cSize div 2
  else if Sender=V3M then
    vSize:=cSize div 4;

  initChr(cSize,cxSize,cySize);

end;

procedure TForm1.csMenuClick(Sender: TObject);
begin

  TMenuItem(Sender).Checked:=True;

  if Sender=cs1M then
    initChr(16,cxSize,cySize)
  else if Sender=cs2M then
    initChr(24,cxSize,cySize)
  else if Sender=cs3M then
    initChr(32,cxSize,cySize)
  else if Sender=cs4M then
    initChr(40,cxSize,cySize)
  else if Sender=cs5M then
    initChr(48,cxSize,cySize);

end;

procedure TForm1.ccMClick(Sender: TObject);
begin

  TMenuItem(Sender).Checked:=True;

  lc:=0;
  rc:=1;

  if Sender=c1M then
    initChr(cSize,4,4)
  else if Sender=c2M then
    initChr(cSize,5,5)
  else if Sender=c3M then
    initChr(cSize,6,6)
  else if Sender=c4M then
    initChr(cSize,8,8)
  else if Sender=c5M then
    initChr(cSize,10,10);

end;

procedure TForm1.memButtonClick(Sender: TObject);
var
  i,j:Integer;
begin

  if Sender=memSaveB then
  begin

    memMap:=Map;
    saveBMP.Width:=chrI.Picture.Bitmap.Width;
    saveBMP.Height:=chrI.Picture.Bitmap.Height;
    saveBMP.Canvas.Draw(0,0,chrBMP);
    mcs:=cSize;
    mcx:=cxSize;
    mcy:=cySize;
    mrc:=rc;
    mlc:=lc;
    mfn:=fn;
    mov:=ov;

    memLoadB.Enabled:=True;

  end
  else if Sender=memLoadB then
  begin

    if not(MessageDlg('LĂ󋵂Đ܂H',
      mtWarning,mbOkCancel,0)=mrOk) then
      Exit;

    Map:=memMap;
    chrI.Picture.Bitmap.Width:=saveBMP.Width;
    chrI.Picture.Bitmap.Height:=saveBMP.Height;
    chrI.Width:=chrI.Picture.Bitmap.Width;
    chrI.Height:=chrI.Picture.Bitmap.Height;
    chrBMP.Width:=chrI.Width;
    chrBMP.Height:=chrI.Height;
    chrBMP.Canvas.Draw(0,0,saveBMP);

    for i:=0 to cySize-1 do
      for j:=0 to cxSize-1 do
        patBMP[j+i*cxSize].Canvas.CopyRect(Rect(0,0,cSize,cSize),
          chrBMP.Canvas,Rect(j*cSize,i*cSize,(j+1)*cSize,(i+1)*cSize));

    drawChr;
    drawChrLine;

    cSize:=mcs;
    cxSize:=mcx;
    cySize:=mcy;
    rc:=mrc;
    lc:=mlc;
    fn:=mfn;
    ov:=mov;
    ud:=False;

    Caption:='}bvGł|'+fn;

    initChr(cSize,cxSize,cySize);
    drawMap;

  end;

end;

procedure TForm1.moveMenuClick(Sender: TObject);
var
  i,j,dx,dy:Integer;
begin

  if Sender=upMenu then
  begin

    for i:=0 to 254 do
      for j:=0 to 255 do
        Map[j,i]:=Map[j,i+1];

    for i:=0 to 255 do
      Map[i,255]:=rc;

  end;

  if Sender=rightMenu then
  begin

    for i:=1 to 255 do
      for j:=0 to 255 do
        Map[255-i+1,j]:=Map[255-i,j];

    for i:=0 to 255 do
      Map[0,i]:=rc;

  end;

  if Sender=downMenu then
  begin

    for i:=1 to 255 do
      for j:=0 to 255 do
        Map[j,255-i+1]:=Map[j,255-i];

    for i:=0 to 255 do
      Map[i,0]:=rc;

  end;

  if Sender=leftMenu then
  begin

    for i:=0 to 254 do
      for j:=0 to 255 do
        Map[i,j]:=Map[i+1,j];

    for i:=0 to 255 do
      Map[255,i]:=rc;

  end;

  drawMap;

end;

procedure TForm1.undoMenuClick(Sender: TObject);
begin

  if Sender=editMenu then
    undoMenu.Enabled:=ud;

  if Sender=undoMenu then
  begin

    Map:=unMap;
    drawMap;
    ud:=False;

  end;

end;

procedure TForm1.aboutMenuClick(Sender: TObject);
begin

  ShowMessage('}bvGł Version1.11 (C)1997-2003 ˁ@P');

end;

procedure TForm1.DropFiles(var Msg:TWMDROPFILES); // t@Chbv̏
var
  FileName: array [0..255] of Char;
  i,j:Integer;
  tBMP:TBitmap;
begin

  DragQueryFile(Msg.Drop,0,FileName,SizeOf(FileName)-1);
  DragFinish(Msg.Drop);

  if AnsiUpperCase(ExtractFileExt(FileName))='.BMP' then
    loadParts(FileName)
  else if AnsiUpperCase(ExtractFileExt(FileName))='.MPD' then
    loadMap(FileName);

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i:Integer;
begin

  if ov then
    if MessageDlg('ۑȂł̂܂܏IĂ낵łH',
       mtWarning,mbOkCancel,0)=mrCancel then
    begin

      Action:=caNone;
      Exit;

    end;

  chrBMP.Free;
  mapBMP.Free;
  saveBMP.Free;

  for i:=0 to 99 do
    patBMP[i].Free;

end;

end.
